package game
{
   import classes.mathematical.Point3D;
   import flash.display.MovieClip;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.events.TimerEvent;
   import flash.geom.Point;
   import flash.media.SoundChannel;
   import flash.utils.Timer;
   import flash.utils.getTimer;
   import game.Guns.Gun;
   import game.panel.Blood;
   import game.panel.Plus50;
   import game.panel.ZombieCloud;
   
   public class GameZombie extends MovieClip
   {
      
      public static const DELETE:String = "Delete";
       
      
      private var krokChannel:SoundChannel;
      
      internal var afterZly:Boolean = false;
      
      internal var AB:int;
      
      public var cloud:ZombieCloud;
      
      internal var startX:Number;
      
      internal var startY:Number;
      
      internal var startZ:Number;
      
      internal var walkTime:Number;
      
      public var posinton:Point3D;
      
      public var speed:Number = 15;
      
      internal var soundID:int;
      
      internal var lastTime:int;
      
      public var isOK:int = 0;
      
      internal var hint:MovieClip;
      
      public var isKillingMe:Boolean;
      
      internal var killAnim:String;
      
      internal var stopZ:Number;
      
      internal var speedMultiplayer:Number;
      
      internal var vPoint:Point;
      
      internal var fl:Number;
      
      internal var stopFireFlag:int;
      
      public var myText:String;
      
      private var zobieChannel:SoundChannel;
      
      internal var zobieTimer:Timer;
      
      internal var isFemale:Boolean;
      
      internal var afterHitAction:String;
      
      internal var armor:int;
      
      internal var questions:QuestionsList;
      
      internal var kill:MovieClip;
      
      private var krokTimer:Timer;
      
      public var isBlowingUp:Boolean;
      
      internal var sManager:SoundManager;
      
      internal var myID:int;
      
      internal var killingTimer:Timer;
      
      public function GameZombie()
      {
         zobieChannel = new SoundChannel();
         speed = 15;
         isOK = 0;
         afterZly = false;
         super();
         speedMultiplayer = Math.random() * 1.9 + 0.6;
         isBlowingUp = false;
         isKillingMe = false;
         questions = ThisGameManager.getInstance().level.getQuestions();
         this.speed = ThisGameManager.getInstance().level.zombieSpeed;
         zobieTimer = new Timer(1,1);
         zobieTimer.addEventListener(TimerEvent.TIMER,giveZombieSound);
         zobieTimer.start();
         AB = 0;
         soundID = Math.floor(Math.random() * ThisGameManager.getInstance().soundManager.krok.length / 2) * 2;
         startX = 0;
         startY = 380;
         startZ = 450000;
         walkTime = 50000;
         stopZ = -25000;
         speed = (startZ - stopZ) / walkTime;
         sManager = ThisGameManager.getInstance().soundManager;
         krokTimer = new Timer(800);
         krokTimer.addEventListener(TimerEvent.TIMER,giveKrokSound);
         killingTimer = new Timer(4000,1);
         killingTimer.addEventListener(TimerEvent.TIMER,afterKilling);
      }
      
      public function veryAngry() : void
      {
         if(--armor > 0)
         {
            this.gotoAndPlay("Nervous");
         }
         else
         {
            this.enabled = false;
            isKillingMe = true;
            if(this.cloud.parent)
            {
               this.removeChild(cloud);
            }
         }
      }
      
      private function afterHit() : void
      {
         if(afterHitAction == "Loop")
         {
            this.gotoAndPlay("Loop");
            this.startMovig();
         }
         else
         {
            this.gotoAndPlay("je");
         }
      }
      
      public function shotMe(param1:MouseEvent) : void
      {
         this.cloud.parent.removeChild(cloud);
         this.stopMoving();
         if(ThisGameManager.getInstance().gun1 == ThisGameManager.getInstance().guns[4])
         {
            this.gotoAndPlay("wybuch");
            this.gotoAndPlay(this.currentFrame - 10);
         }
         else
         {
            this.gotoAndPlay("rozpad");
         }
         ThisGameManager.getInstance().gun1.addEventListener(Gun.FIRE_CPLT,stopFire);
         ThisGameManager.getInstance().gun2.addEventListener(Gun.FIRE_CPLT,stopFire);
         stopFireFlag = 0;
      }
      
      public function afterKilling() : void
      {
         this.deleteMe();
         ThisGameManager.getInstance().level.killMe();
      }
      
      private function givePerspective() : void
      {
         var _loc1_:Number = NaN;
         _loc1_ = fl / (fl + posinton.Z);
         this.scaleX = this.scaleY = _loc1_;
         this.x = vPoint.x + posinton.X * _loc1_;
         this.y = vPoint.y + posinton.Y * _loc1_;
      }
      
      private function fireMe(param1:TimerEvent) : void
      {
         ThisGameManager.getInstance().gun1.fire(new Point(this.x,this.y - this.height / 2));
         ThisGameManager.getInstance().gun2.fire(new Point(this.x,this.y - this.height / 2));
      }
      
      public function deleteMe() : void
      {
         if(zobieTimer.running)
         {
            zobieTimer.stop();
         }
         stopMoving();
         this.stop();
         if(this.parent)
         {
            this.parent.removeChild(this);
         }
         dispatchEvent(new Event(GameZombie.DELETE));
      }
      
      private function afterEating(param1:TimerEvent) : void
      {
         this.gotoAndPlay("rozpad");
         sManager.giveBonesSound();
      }
      
      private function giveZombieSound(param1:TimerEvent) : void
      {
         var _loc2_:Array = null;
         var _loc3_:int = 0;
         var _loc4_:int = 0;
         if(ThisGameManager.getInstance().mute)
         {
            return;
         }
         zobieTimer.delay = 2000 + Math.random() * 5500;
         zobieTimer.reset();
         zobieTimer.start();
         zobieChannel.stop();
         _loc2_ = ThisGameManager.getInstance().level.levelZombies;
         if(ThisGameManager.getInstance().level.levelZombies.length == 0)
         {
            return;
         }
         _loc3_ = 5;
         _loc4_ = 0;
         while(_loc4_ < ThisGameManager.getInstance().level.levelZombies.length)
         {
            if(_loc2_[_loc4_] == this)
            {
               _loc3_ = _loc4_;
               break;
            }
            _loc4_++;
         }
         if(_loc4_ < 2)
         {
            if(isFemale)
            {
               zobieChannel = sManager.zombieF[Math.floor(Math.random() * sManager.zombieF.length)].play(1,1);
            }
            else
            {
               zobieChannel = sManager.zombie[Math.floor(Math.random() * sManager.zombie.length)].play(1,1);
            }
         }
      }
      
      public function getStopZ() : Number
      {
         return stopZ;
      }
      
      public function stopMoving() : void
      {
         this.removeEventListener(Event.ENTER_FRAME,moveMe);
         this.stop();
         if(krokTimer.running)
         {
            krokTimer.stop();
         }
         if(afterZly)
         {
            return;
         }
      }
      
      public function setKillAnim(param1:String) : void
      {
         this.killAnim = param1;
      }
      
      public function blowMeUp() : void
      {
         isBlowingUp = true;
         if(this.cloud.parent)
         {
            this.cloud.parent.removeChild(cloud);
         }
         this.gotoAndPlay("wybuch");
         if(ThisGameManager.getInstance().gun1 == ThisGameManager.getInstance().guns[4])
         {
            this.gotoAndPlay(this.currentFrame - 12);
         }
      }
      
      public function getStartZ() : Number
      {
         return startZ;
      }
      
      public function setZombie(param1:int, param2:Boolean = false, param3:Number = 0, param4:Number = 450000, param5:Number = 380) : Boolean
      {
         var _loc6_:Object = null;
         cloud = new ZombieCloud();
         myText = questions.giveText(param1).toLowerCase();
         cloud.setText(myText);
         cloud.clearHighLight();
         myID = ThisGameManager.getInstance().level.zombieID++;
         ThisGameManager.getInstance().level.levelZombiesQuestions.push(new Question(myID,myText));
         this.addChild(cloud);
         vPoint = ThisGameManager.getInstance().background.getVanishingPoint();
         fl = ThisGameManager.getInstance().background.getFocalLenght();
         posinton = new Point3D(param3,param5 - vPoint.y,param4);
         givePerspective();
         startMovig(param2);
         cloud.y = -280 - 160 * (posinton.Z - stopZ) / (startZ - stopZ);
         return true;
      }
      
      private function giveKrokSound(param1:TimerEvent) : void
      {
         var _loc2_:Array = null;
         var _loc3_:int = 0;
         if(ThisGameManager.getInstance().mute)
         {
            return;
         }
         _loc2_ = ThisGameManager.getInstance().level.levelZombies;
         if(ThisGameManager.getInstance().level.levelZombies.length == 0)
         {
            return;
         }
         _loc3_ = 0;
         while(_loc3_ < ThisGameManager.getInstance().level.levelZombies.length)
         {
            if(_loc2_[_loc3_] == this)
            {
               break;
            }
            _loc3_++;
         }
         if(_loc3_ < 2)
         {
            krokChannel = sManager.krok[soundID + AB % 2].play();
         }
         ++AB;
      }
      
      private function moveMe(param1:Event) : void
      {
         var _loc2_:Number = NaN;
         speed -= 0.001;
         _loc2_ = (getTimer() - lastTime) * speed * speedMultiplayer;
         lastTime = getTimer();
         this.posinton.Z -= _loc2_;
         givePerspective();
         if(posinton.Z < 0 && posinton.X + vPoint.x < 200)
         {
            posinton.X += 0.7;
         }
         if(posinton.Z < 0 && posinton.X + vPoint.x > 600)
         {
            posinton.X -= 0.7;
         }
         if(posinton.Z < -25000)
         {
            this.killMe();
         }
         cloud.scaleX = cloud.scaleY = 1 / this.scaleX;
         cloud.y = -280 - 160 * (posinton.Z - stopZ) / (startZ - stopZ);
      }
      
      public function eat() : void
      {
         afterHitAction = "Loop";
         if(isOK != 0)
         {
         }
      }
      
      private function stopFire(param1:Event) : void
      {
         param1.target.removeEventListener(Gun.FIRE_CPLT,stopFire);
         ++stopFireFlag;
      }
      
      public function giveBlood() : void
      {
         ThisGameManager.getInstance().addChild(new Blood());
         sManager.giveKillingSound();
      }
      
      public function give50() : void
      {
         if(!isBlowingUp)
         {
            this.addChild(new Plus50());
         }
      }
      
      public function setIsFemale(param1:Boolean) : void
      {
         this.isFemale = param1;
      }
      
      private function hit() : void
      {
         this.stopMoving();
         afterHit();
      }
      
      private function killMe() : void
      {
         if(isBlowingUp)
         {
            return;
         }
         armor = ThisGameManager.getInstance().player.armorLevel;
         this.stopMoving();
         afterZly = true;
         this.gotoAndPlay("zly");
      }
      
      public function jumpWybuch() : void
      {
         if(ThisGameManager.getInstance().player.currentGunID == 1 || ThisGameManager.getInstance().player.currentBulletsIDs[ThisGameManager.getInstance().player.currentGunID] == 1 || ThisGameManager.getInstance().player.currentBulletsIDs[ThisGameManager.getInstance().player.currentGunID] == 3)
         {
            this.gotoAndPlay("wybuch");
         }
      }
      
      public function startMovig(param1:Boolean = true) : void
      {
         var _loc2_:int = 0;
         this.addEventListener(Event.ENTER_FRAME,moveMe);
         lastTime = getTimer();
         if(param1)
         {
            this.play();
         }
         else
         {
            this.gotoAndPlay("Loop");
         }
         krokTimer.start();
         _loc2_ = 0;
         while(_loc2_ < this.numChildren)
         {
            if(this.getChildAt(_loc2_) != null && this.getChildAt(_loc2_) != hint)
            {
               MovieClip(this.getChildAt(_loc2_)).play();
            }
            _loc2_++;
         }
      }
   }
}
