package game.Guns
{
   import flash.display.MovieClip;
   import flash.events.Event;
   import flash.events.EventDispatcher;
   import flash.events.MouseEvent;
   import flash.events.TimerEvent;
   import flash.geom.Point;
   import flash.utils.Timer;
   import game.Player;
   import game.SoundManager;
   import game.ThisGameManager;
   
   public class Gun extends MovieClip
   {
      
      internal static var fireNow:EventDispatcher = new EventDispatcher();
      
      public static var SHOT:String = "shot";
      
      public static var FIRE_START:String = "fire_start";
      
      public static var SHOT_CPLT:String = "shot_complit";
      
      public static var FIRE_CPLT:String = "fire_complit";
       
      
      internal var ID:int;
      
      internal var animEnd:Point;
      
      internal var yMax:int = 225;
      
      public var isHiding:Boolean = false;
      
      protected var fast:String;
      
      internal var shotingTarget:Point;
      
      internal var barelEnd:MovieClip;
      
      public var bullets:int;
      
      internal var startPosition:Point;
      
      protected var sManager:SoundManager;
      
      internal var xMax:int = 400;
      
      internal var animStart:Point;
      
      internal var shots:int = 5;
      
      internal var player:Player;
      
      public function Gun()
      {
         yMax = 225;
         xMax = 400;
         shots = 5;
         isHiding = false;
         super();
         player = ThisGameManager.getInstance().player;
         this.stop();
         sManager = ThisGameManager.getInstance().soundManager;
         startPosition = parent.localToGlobal(new Point(this.x,this.y));
         bullets = 100;
         barelEnd = MovieClip(this.getChildByName("ending"));
      }
      
      protected function luskiSound(param1:Event) : void
      {
         sManager.giveLuskiSound();
      }
      
      public function showGun() : void
      {
         animEnd = new Point(startPosition.x + (400 - xMax) / 2,startPosition.y + (250 - yMax) / 2);
         this.addEventListener(Event.ENTER_FRAME,animateMove);
      }
      
      public function burstByFrames(param1:Point) : void
      {
         shotingTarget = param1;
         this.addEventListener(SHOT_CPLT,fireStrtByFrames);
         this.gotoAndPlay(fast);
         fire(shotingTarget);
      }
      
      public function fire(param1:Point) : void
      {
         if(this.ID == 1)
         {
            --player.bullets[player.currentGunID][player.currentBulletsIDs[player.currentGunID]];
         }
         dispatchEvent(new Event(SHOT));
      }
      
      private function animateMove(param1:Event) : void
      {
         var _loc2_:Number = NaN;
         _loc2_ = 5;
         if(Math.abs(this.x - animEnd.x) > 5)
         {
            this.x += (animEnd.x - this.x) / _loc2_;
         }
         else
         {
            this.x = Math.round(animEnd.x);
         }
         if(Math.abs(this.y - animEnd.y) > 5)
         {
            this.y += (animEnd.y - this.y) / _loc2_;
         }
         else
         {
            this.y = Math.round(animEnd.y);
         }
         if(this.x == Math.round(animEnd.x) && this.y == Math.round(animEnd.y))
         {
            this.removeEventListener(Event.ENTER_FRAME,animateMove);
            if(fireNow.hasEventListener(FIRE_START))
            {
               fireNow.addEventListener(FIRE_START,giveBurst);
               fireNow.dispatchEvent(new Event(FIRE_START));
            }
            else
            {
               fireNow.addEventListener(FIRE_START,giveBurst);
            }
         }
      }
      
      public function setStartPosition(param1:Point) : void
      {
         this.startPosition = param1;
      }
      
      public function fireInAir(param1:int) : void
      {
         fireTo(400,300,param1);
      }
      
      public function moveGunTo(param1:int, param2:int) : void
      {
         var _loc3_:Point = null;
         _loc3_ = new Point(this.x,this.y);
         _loc3_ = this.parent.localToGlobal(_loc3_);
         this.x = startPosition.x + (param1 - xMax) / 2;
         this.y = startPosition.y + (param2 - yMax) / 2;
      }
      
      public function fireTo(param1:int, param2:int, param3:int) : void
      {
         var _loc4_:Number = NaN;
         this.shots = param3;
         shotingTarget = new Point(param1,param2);
         _loc4_ = 2;
         animStart = new Point(this.x,this.y);
         animEnd = new Point(startPosition.x + (param1 - xMax) / _loc4_,startPosition.y + (param2 - yMax) / _loc4_);
         this.addEventListener(Event.ENTER_FRAME,animateMove);
      }
      
      public function getBarrelEnd() : Point
      {
         return this.localToGlobal(new Point(barelEnd.x,barelEnd.y));
      }
      
      private function giveBurst(param1:Event) : void
      {
         param1.target.removeEventListener(FIRE_START,giveBurst);
         if(!isHiding)
         {
            burstByFrames(shotingTarget);
         }
         dispatchEvent(new Event(FIRE_START));
      }
      
      public function hideGun() : void
      {
         isHiding = true;
         animEnd = new Point(startPosition.x + (400 - xMax) / 2,startPosition.y + (500 - yMax) / 2);
         this.addEventListener(Event.ENTER_FRAME,animateMove);
      }
      
      private function moveGun(param1:MouseEvent) : void
      {
         var _loc2_:Point = null;
         _loc2_ = new Point(this.x,this.y);
         _loc2_ = this.parent.localToGlobal(_loc2_);
         if(Math.abs(MovieClip(param1.currentTarget).mouseY - _loc2_.y) > yMax)
         {
            this.height = yMax;
         }
         else
         {
            this.height = Math.abs(MovieClip(param1.currentTarget).mouseY - _loc2_.y);
         }
         if(Math.abs(MovieClip(param1.currentTarget).mouseX - _loc2_.x) > xMax)
         {
            this.width = xMax;
         }
         else
         {
            this.width = Math.abs(MovieClip(param1.currentTarget).mouseX - _loc2_.x);
         }
         param1.updateAfterEvent();
      }
      
      private function fireStrtByFrames(param1:Event) : void
      {
         if(shots > 1)
         {
            this.gotoAndPlay(fast);
            fire(shotingTarget);
            --shots;
         }
         else
         {
            --shots;
            this.removeEventListener(SHOT_CPLT,fireStrtByFrames);
            this.gotoAndStop(1);
            dispatchEvent(new Event(FIRE_CPLT));
         }
      }
      
      private function stopFireByTimer(param1:TimerEvent) : void
      {
         param1.target.removeEventListener(TimerEvent.TIMER,fireStartByTimer);
         param1.target.removeEventListener(TimerEvent.TIMER_COMPLETE,stopFireByTimer);
         dispatchEvent(new Event(FIRE_CPLT));
      }
      
      private function fireStartByTimer(param1:TimerEvent) : void
      {
         fire(shotingTarget);
      }
      
      public function burstByTimer(param1:Point) : void
      {
         var _loc2_:Timer = null;
         shotingTarget = param1;
         _loc2_ = new Timer(100,int(shots) / 2 + 1);
         _loc2_.addEventListener(TimerEvent.TIMER,fireStartByTimer);
         _loc2_.addEventListener(TimerEvent.TIMER_COMPLETE,stopFireByTimer);
         _loc2_.start();
      }
      
      public function setID(param1:int) : void
      {
         ID = param1;
      }
   }
}
