package game.powerUps
{
   import classes.mathematical.Point3D;
   import flash.display.MovieClip;
   import flash.events.Event;
   import flash.geom.Point;
   import game.QuestionsList;
   import game.SoundManager;
   import game.ThisGameManager;
   import game.panel.ZombieCloud;
   
   public class PowerUp extends MovieClip
   {
      
      public static const DELETE:String = "Delete";
      
      protected static var places:Array = new Array();
       
      
      public var cloud:ZombieCloud;
      
      public var posinton:Point3D;
      
      internal var questions:QuestionsList;
      
      internal var vPoint:Point;
      
      internal var sManager:SoundManager;
      
      internal var fl:Number;
      
      public var myText:String;
      
      public function PowerUp()
      {
         super();
         this.cacheAsBitmap = true;
         sManager = ThisGameManager.getInstance().soundManager;
         if(places.length == 0)
         {
            setPlaces();
         }
      }
      
      public static function getPlaces() : Array
      {
         return places;
      }
      
      private function setPlaces() : void
      {
         var _loc1_:Number = NaN;
         var _loc2_:Number = NaN;
         var _loc3_:int = 0;
         _loc1_ = -50;
         _loc2_ = 880;
         _loc3_ = 450000;
         while(_loc3_ > 45000)
         {
            places.push([_loc1_,_loc3_,false]);
            places.push([_loc2_,_loc3_,false]);
            _loc3_ -= 45000;
         }
      }
      
      protected function givePerspective() : void
      {
         var _loc1_:Number = NaN;
         _loc1_ = fl / (fl + posinton.Z);
         this.scaleX = this.scaleY = _loc1_;
         this.x = vPoint.x + posinton.X * _loc1_;
         this.y = vPoint.y + posinton.Y * _loc1_;
      }
      
      public function killMySlef() : void
      {
         deleteMe();
      }
      
      public function giveMeWhatYouHave() : void
      {
      }
      
      public function setMe(param1:int) : Boolean
      {
         vPoint = ThisGameManager.getInstance().background.getVanishingPoint();
         if(!setPosition())
         {
            return false;
         }
         questions = ThisGameManager.getInstance().level.getQuestions();
         cloud = new ZombieCloud();
         myText = questions.giveText(param1).toLowerCase();
         cloud.setText(myText);
         cloud.clearHighLight();
         cloud.y -= 130;
         this.addChild(cloud);
         fl = ThisGameManager.getInstance().background.getFocalLenght();
         givePerspective();
         cloud.scaleX = 1 / this.scaleX;
         cloud.scaleY = 1 / this.scaleY;
         return true;
      }
      
      public function deleteMe() : void
      {
         if(this.parent)
         {
            this.parent.removeChild(this);
         }
         dispatchEvent(new Event(DELETE));
      }
      
      protected function setPosition() : Boolean
      {
         var _loc1_:int = 0;
         _loc1_ = 0;
         while(_loc1_ < places.length)
         {
            if(places[_loc1_][2])
            {
               this.posinton = new Point3D(places[_loc1_][0] - vPoint.x,380 - vPoint.y,places[_loc1_][1]);
               return true;
            }
            _loc1_++;
         }
         return false;
      }
   }
}
