package game.upgrades
{
   import classes.mathematical.Point3D;
   import flash.display.MovieClip;
   import flash.events.Event;
   import flash.geom.Point;
   import flash.media.SoundChannel;
   import game.GameZombie;
   import game.Player;
   import game.SoundManager;
   import game.ThisGameManager;
   
   [Embed(source="/_assets/assets.swf", symbol="game.upgrades.ElectricFence")]
   public class ElectricFence extends MovieClip
   {
       
      
      internal var zombies:Array;
      
      internal var chanell:SoundChannel;
      
      private var killNum:Array;
      
      public var posinton:Point3D;
      
      internal var vPoint:Point;
      
      internal var sManager:SoundManager;
      
      internal var fl:Number;
      
      private var intervalId:uint;
      
      internal var timeOnStage:int = 5000;
      
      internal var player:Player;
      
      internal var zombiesToKill:int;
      
      public function ElectricFence()
      {
         var _loc1_:int = 0;
         var _loc2_:int = 0;
         timeOnStage = 5000;
         chanell = new SoundChannel();
         super();
         addFrameScript(32,frame33);
         killNum = [1,3,5,7];
         sManager = ThisGameManager.getInstance().soundManager;
         if(!ThisGameManager.getInstance().mute)
         {
            sManager.electricStart.play();
         }
         if(!ThisGameManager.getInstance().mute)
         {
            chanell = sManager.electricLoop.play(1,int.MAX_VALUE);
         }
         zombies = ThisGameManager.getInstance().level.levelZombies;
         player = ThisGameManager.getInstance().player;
         vPoint = ThisGameManager.getInstance().background.getVanishingPoint();
         fl = ThisGameManager.getInstance().background.getFocalLenght();
         posinton = new Point3D(-50 - vPoint.x,380 - vPoint.y,200000 - 30000 * player.electricFenceLevel);
         zombiesToKill = killNum[player.electricFenceLevel - 1];
         givePerspective();
         this.addEventListener(Event.ENTER_FRAME,killZombies);
         ThisGameManager.getInstance().level.elcticFence = this;
         _loc1_ = ThisGameManager.getInstance().level.numChildren;
         _loc2_ = 0;
         while(_loc2_ < ThisGameManager.getInstance().level.numChildren)
         {
            if(GameZombie(ThisGameManager.getInstance().level.getChildAt(_loc2_)).posinton.Z < this.posinton.Z)
            {
               _loc1_ = _loc2_;
               break;
            }
            _loc2_++;
         }
         ThisGameManager.getInstance().level.addChildAt(this,_loc1_);
      }
      
      private function givePerspective() : void
      {
         var _loc1_:Number = NaN;
         _loc1_ = fl / (fl + posinton.Z);
         this.scaleX = this.scaleY = _loc1_;
         this.x = vPoint.x + posinton.X * _loc1_;
         this.y = vPoint.y + posinton.Y * _loc1_;
      }
      
      public function kill() : void
      {
         chanell.stop();
         this.removeEventListener(Event.ENTER_FRAME,killZombies);
         this.parent.removeChild(this);
         ThisGameManager.getInstance().level.elcticFence = null;
      }
      
      private function killMySlef() : void
      {
         chanell.stop();
         if(!ThisGameManager.getInstance().mute)
         {
            sManager.electricStart.play();
         }
         this.removeEventListener(Event.ENTER_FRAME,killZombies);
         this.parent.removeChild(this);
         ThisGameManager.getInstance().level.elcticFence = null;
      }
      
      internal function frame33() : *
      {
         stop();
      }
      
      private function killZombies(param1:Event) : void
      {
         var _loc2_:int = 0;
         _loc2_ = 0;
         while(_loc2_ < zombies.length)
         {
            if(!GameZombie(zombies[_loc2_]).isBlowingUp && Math.abs(GameZombie(zombies[_loc2_]).posinton.Z - this.posinton.Z) < 1000)
            {
               if(!ThisGameManager.getInstance().mute)
               {
                  sManager.electricShock.play();
               }
               GameZombie(zombies[_loc2_]).blowMeUp();
               --zombiesToKill;
               if(zombiesToKill == 0)
               {
                  this.killMySlef();
               }
            }
            _loc2_++;
         }
      }
   }
}
